// -*- Java -*-
/*!
 * @file  RobotDummyImpl.java
 * @brief ModuleDescription
 * @date  $Date$
 *
 * $Id$
 */

import RTC.TimedLong;
import jp.go.aist.rtm.RTC.DataFlowComponentBase;
import jp.go.aist.rtm.RTC.Manager;
import jp.go.aist.rtm.RTC.port.InPort;
import jp.go.aist.rtm.RTC.util.DataRef;
import jp.go.aist.rtm.RTC.port.CorbaConsumer;
import jp.go.aist.rtm.RTC.port.CorbaPort;
import RTC.ReturnCode_t;
//import SIP2.spRobotPath;
import SIP2.*;


/*!
 * @class RobotDummyImpl
 * @brief ModuleDescription
 *
 */
public class RobotDummyImpl extends DataFlowComponentBase {

  /*!
   * @brief constructor
   * @param manager Maneger Object
   */
	public RobotDummyImpl(Manager manager) {  
        super(manager);
        // <rtc-template block="initializer">
        m_upperlimit_val = new TimedLong();
        m_upperlimit = new DataRef<TimedLong>(m_upperlimit_val);
        m_upperlimitIn = new InPort<TimedLong>("upperlimit", m_upperlimit);
        m_spRobotPathPort = new CorbaPort("spRobotPath");
        // </rtc-template>

    }

    /**
     *
     * The initialize action (on CREATED->ALIVE transition)
     * formaer rtc_init_entry() 
     *
     * @return RTC::ReturnCode_t
     * 
     * 
     */
    @Override
    protected ReturnCode_t onInitialize() {
        // Registration: InPort/OutPort/Service
        // <rtc-template block="registration">
        // Set InPort buffers
        addInPort("upperlimit", m_upperlimitIn);
        
        // Set service consumers to Ports
        m_spRobotPathPort.registerConsumer("spRobotPath", "SIP2::spRobotPath", m_spRobotPathBase);
        
        // Set CORBA Service Ports
        addPort(m_spRobotPathPort);
        // </rtc-template>
        return super.onInitialize();
    }

    /***
     *
     * The finalize action (on ALIVE->END transition)
     * formaer rtc_exiting_entry()
     *
     * @return RTC::ReturnCode_t
     * 
     * 
     */
//    @Override
//    protected ReturnCode_t onFinalize() {
//        return super.onFinalize();
//    }

    /***
     *
     * The startup action when ExecutionContext startup
     * former rtc_starting_entry()
     *
     * @param ec_id target ExecutionContext Id
     *
     * @return RTC::ReturnCode_t
     * 
     * 
     */
//    @Override
//    protected ReturnCode_t onStartup(int ec_id) {
//        return super.onStartup(ec_id);
//    }

    /***
     *
     * The shutdown action when ExecutionContext stop
     * former rtc_stopping_entry()
     *
     * @param ec_id target ExecutionContext Id
     *
     * @return RTC::ReturnCode_t
     * 
     * 
     */
//    @Override
//    protected ReturnCode_t onShutdown(int ec_id) {
//        return super.onShutdown(ec_id);
//    }

    /***
     *
     * The activated action (Active state entry action)
     * former rtc_active_entry()
     *
     * @param ec_id target ExecutionContext Id
     *
     * @return RTC::ReturnCode_t
     * 
     * 
     */
//    @Override
//    protected ReturnCode_t onActivated(int ec_id) {
//        return super.onActivated(ec_id);
//    }

    /***
     *
     * The deactivated action (Active state exit action)
     * former rtc_active_exit()
     *
     * @param ec_id target ExecutionContext Id
     *
     * @return RTC::ReturnCode_t
     * 
     * 
     */
//    @Override
//    protected ReturnCode_t onDeactivated(int ec_id) {
//        return super.onDeactivated(ec_id);
//    }

    /***
     *
     * The execution action that is invoked periodically
     * former rtc_active_do()
     *
     * @param ec_id target ExecutionContext Id
     *
     * @return RTC::ReturnCode_t
     * 
     * 
     */
    @Override
    protected ReturnCode_t onExecute(int ec_id) {
      		m_spRobotPath = m_spRobotPathBase._ptr();
       		if (m_spRobotPath._non_existent()) {
       			return super.onExecute(ec_id);
       		}

       		CurrentStatus p = new CurrentStatus();
        	p.NodeID = 4;
        	p.status = 0;
        	
        	boolean po;
        	po = m_spRobotPath.setCurrentStatus(p);
        	if (po == true){
        		System.out.print("JgXe[^XZbgv܂\n");
        	}
        	
        	Node[] map = new Node[8];
        	Node[] pathNodes = new Node[6];
        	
    		map[0] = new Node();
    		map[0].name="Point1";
       		map[0].id = 1;
       		map[0].xPos = 0.0;
       		map[0].yPos = 0.0;   		
    		map[1] = new Node();
    		map[1].name="Point2";
       		map[1].id = 2;
       		map[1].xPos = 0.0;
       		map[1].yPos = 2000.0;
    		map[2] = new Node();
    		map[2].name="Point3";
       		map[2].id = 3;
       		map[2].xPos = 2000.0;
       		map[2].yPos = 2000.0;
    		map[3] = new Node();
    		map[3].name="Point4";
       		map[3].id = 4;
       		map[3].xPos = 4000.0;
       		map[3].yPos = 2000.0;
    		map[4] = new Node();
    		map[4].name="Point5";
       		map[4].id = 5;
       		map[4].xPos = 2000.0;
       		map[4].yPos = 0.0;
    		map[5] = new Node();
    		map[5].name="Point6";
       		map[5].id = 6;
       		map[5].xPos = 4000.0;
       		map[5].yPos = 0.0;
    		map[6] = new Node();
    		map[6].name="Point7";
       		map[6].id = 7;
       		map[6].xPos = 6000.0;
       		map[6].yPos = 2000.0;
    		map[7] = new Node();
    		map[7].name="Point8";
       		map[7].id = 8;
       		map[7].xPos = 8000.0;
       		map[7].yPos = 2000.0;

    		pathNodes[0] = new Node();
    		pathNodes[0].name="def";
       		pathNodes[0].id = 1;
    		pathNodes[1] = new Node();
    		pathNodes[1].name="def";
       		pathNodes[1].id = 5;
    		pathNodes[2] = new Node();
    		pathNodes[2].name="def";
       		pathNodes[2].id = 6;
    		pathNodes[3] = new Node();
    		pathNodes[3].name="def";
       		pathNodes[3].id = 4;
    		pathNodes[4] = new Node();
    		pathNodes[4].name="def";
       		pathNodes[4].id = 7;
    		pathNodes[5] = new Node();
    		pathNodes[5].name="def";
       		pathNodes[5].id = 8;

        	po = m_spRobotPath.setRobotPath(map, pathNodes);
        	if (po == true){
        		System.out.print("}bvȂǃZbgv܂\n");
        	}

     
            if( m_upperlimitIn.isNew() ) {
            	 m_upperlimitIn.read();
                 System.out.print("擾Abp[~bg" + m_upperlimit.v.data + "\n" );
            }
            try {
            	Thread.sleep(1);
            } catch (InterruptedException e) {
            	e.printStackTrace();
            }
            return super.onExecute(ec_id);
        }

    /***
     *
     * The aborting action when main logic error occurred.
     * former rtc_aborting_entry()
     *
     * @param ec_id target ExecutionContext Id
     *
     * @return RTC::ReturnCode_t
     * 
     * 
     */
//  @Override
//  public ReturnCode_t onAborting(int ec_id) {
//      return super.onAborting(ec_id);
//  }

    /***
     *
     * The error action in ERROR state
     * former rtc_error_do()
     *
     * @param ec_id target ExecutionContext Id
     *
     * @return RTC::ReturnCode_t
     * 
     * 
     */
//    @Override
//    public ReturnCode_t onError(int ec_id) {
//        return super.onError(ec_id);
//    }

    /***
     *
     * The reset action that is invoked resetting
     * This is same but different the former rtc_init_entry()
     *
     * @param ec_id target ExecutionContext Id
     *
     * @return RTC::ReturnCode_t
     * 
     * 
     */
//    @Override
//    protected ReturnCode_t onReset(int ec_id) {
//        return super.onReset(ec_id);
//    }

    /***
     *
     * The state update action that is invoked after onExecute() action
     * no corresponding operation exists in OpenRTm-aist-0.2.0
     *
     * @param ec_id target ExecutionContext Id
     *
     * @return RTC::ReturnCode_t
     * 
     * 
     */
//    @Override
//    protected ReturnCode_t onStateUpdate(int ec_id) {
//        return super.onStateUpdate(ec_id);
//    }

    /***
     *
     * The action that is invoked when execution context's rate is changed
     * no corresponding operation exists in OpenRTm-aist-0.2.0
     *
     * @param ec_id target ExecutionContext Id
     *
     * @return RTC::ReturnCode_t
     * 
     * 
     */
//    @Override
//    protected ReturnCode_t onRateChanged(int ec_id) {
//        return super.onRateChanged(ec_id);
//    }
//
    // DataInPort declaration
    // <rtc-template block="inport_declare">
    protected TimedLong m_upperlimit_val;
    protected DataRef<TimedLong> m_upperlimit;
    /*!
     */
    protected InPort<TimedLong> m_upperlimitIn;

    
    // </rtc-template>

    // DataOutPort declaration
    // <rtc-template block="outport_declare">
    
    // </rtc-template>

    // CORBA Port declaration
    // <rtc-template block="corbaport_declare">
    /*!
     */
    protected CorbaPort m_spRobotPathPort;
    
    // </rtc-template>

    // Service declaration
    // <rtc-template block="service_declare">
    
    // </rtc-template>

    // Consumer declaration
    // <rtc-template block="consumer_declare">
    protected CorbaConsumer<spRobotPath> m_spRobotPathBase = new CorbaConsumer<spRobotPath>(spRobotPath.class);
    /*!
     */
    protected spRobotPath m_spRobotPath;
    
    // </rtc-template>


}
